package com.poststats.rs.api.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.poststats.rs.api.annotation.MapEntry;

/**
 * @author brian.long@poststats.com
 */
public abstract class BaseFacility<ConcreteT extends BaseFacility<ConcreteT>> extends BaseModel<ConcreteT> {

	@JsonProperty(required = true)
	@MapEntry("facility")
	private String name;

	@JsonProperty()
	@MapEntry("prefix")
	private String namePrefix;

	@JsonProperty(required = true)
	@MapEntry("suffix")
	private String nameSuffix;

	@JsonProperty(required = true)
	private String postalAddress;

	@JsonProperty
	@MapEntry("www")
	private String webAddress;

	@JsonProperty
	@MapEntry("contact")
	private String contact;

	@JsonProperty
	@MapEntry("phone1")
	private String phoneNumber;

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getNamePrefix() {
		return namePrefix;
	}

	public void setNamePrefix(String namePrefix) {
		this.namePrefix = namePrefix;
	}

	public String getNameSuffix() {
		return nameSuffix;
	}

	public void setNameSuffix(String nameSuffix) {
		this.nameSuffix = nameSuffix;
	}

	public String getPostalAddress() {
		return postalAddress;
	}

	public void setPostalAddress(String postalAddress) {
		this.postalAddress = postalAddress;
	}

	public String getWebAddress() {
		return webAddress;
	}

	public void setWebAddress(String webAddress) {
		this.webAddress = webAddress;
	}

	public String getContact() {
		return contact;
	}

	public void setContact(String contact) {
		this.contact = contact;
	}

	public String getPhoneNumber() {
		return phoneNumber;
	}

	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}

	public ConcreteT withName(String name) {
		this.name = name;
		return this.withThis();
	}

	public ConcreteT withNamePrefix(String prefix) {
		this.namePrefix = prefix;
		return this.withThis();
	}

	public ConcreteT withNameSuffix(String suffix) {
		this.nameSuffix = suffix;
		return this.withThis();
	}

	public ConcreteT withPostalAddress(String postalAddress) {
		this.postalAddress = postalAddress;
		return this.withThis();
	}

	public ConcreteT withWebAddress(String webAddress) {
		this.webAddress = webAddress;
		return this.withThis();
	}

	public ConcreteT withContact(String contact) {
		this.contact = contact;
		return this.withThis();
	}

	public ConcreteT withPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
		return this.withThis();
	}

}
